/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.kandidatur.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur;
import de.ivu.elect.business.kandidatur.entity.ErsatzkandidaturUK;

public abstract class AbstractErsatzkandidaturDAO extends de.ivu.elect.jee.entity.AbstractDAO<Ersatzkandidatur,
      de.ivu.elect.business.person.entity.PersonendatenPK
  , ErsatzkandidaturUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractErsatzkandidaturDAO.class);

  public AbstractErsatzkandidaturDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.person.entity.PersonendatenPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Ersatzkandidatur findByPrimaryKey(
      de.ivu.elect.business.person.entity.PersonendatenPK
    pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Ersatzkandidatur findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Ersatzkandidatur.class, id, CACHE_PROPERTIES);
  }





  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.kandidatur.entity.ErsatzkandidaturUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.kandidatur.entity.ErsatzkandidaturUK uk,
      de.ivu.elect.business.person.entity.PersonendatenPK
    pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur findByUK(de.ivu.elect.business.kandidatur.entity.ErsatzkandidaturUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}